libdap::HTTPConnect Class Reference

`#include <HTTPConnect.h>`

## Friends

class | HTTPConnectTest
class | ParseHeader
size_t | save_raw_http_header (void *ptr, size_t size, size_t nmemb, void *http_connect)

## Suppress default methods

These methods are not supported and are implemented here as protected methods to suppress the C++-supplied default versions (which will break this object).
| HTTPConnect ()
| HTTPConnect (const HTTPConnect &)
HTTPConnect & | operator= (const HTTPConnect &)
| HTTPConnect (RCReader *rcr, bool use_cpp=false)
virtual | ~HTTPConnect ()
void | set_credentials (const string &u, const string &p)
void | set_accept_deflate (bool defalte)
void | set_xdap_protocol (int major, int minor)
bool | use_cpp_streams () const
void | set_use_cpp_streams (bool use_cpp_streams)
void | set_cookie_jar (const string &cookie_jar)
void | set_cache_enabled (bool enabled)
bool | is_cache_enabled ()
HTTPResponse * | fetch_url (const string &url)

## Detailed Description

Use the CURL library to dereference a HTTP URL. Scan the response for headers used by DAP 2.0 and extract their values. The body of the response is made available using a FILE pointer.

Author
  jhrg

Definition at line 73 of file HTTPConnect.h.

## Constructor & Destructor Documentation

## HTTPConnect()

libdap::HTTPConnect::HTTPConnect | ( | RCReader * | rcr,
|  | bool | use_cpp = `false`
| ) |  |

Build a virtual connection to a remote data source that will be accessed using HTTP.

Parameters

  rcr | A pointer to the RCReader object which holds configuration file information to be used by this virtual connection.

Definition at line 561 of file HTTPConnect.cc.

## Member Function Documentation

## fetch_url()

HTTPResponse * libdap::HTTPConnect::fetch_url | ( | const string & | url | ) |

Dereference a URL. This method dereferences a URL and stores the result (i.e., it formulates an HTTP request and processes the HTTP server's response). After this method is successfully called, the value of is_response_present() will be true and the methods get_response_headers(), type() and server_version() may be called.

Parameters

  url | The URL to dereference.

Returns
  A pointer to the stream.

Exceptions

  Error | Thrown if the URL could not be dereferenced.
  InternalErr | Thrown if a temporary file to hold the response could not be opened.

Definition at line 632 of file HTTPConnect.cc.

## is_cache_enabled()

bool libdap::HTTPConnect::is_cache_enabled | ( |  | ) |

inline

Return the current state of the HTTP cache.

Definition at line 157 of file HTTPConnect.h.

## set_accept_deflate()

void libdap::HTTPConnect::set_accept_deflate | ( | bool | deflate | ) |

Set the accept deflate property. If true, the DAP client announces to a server that it can accept responses compressed using the `deflate` algorithm. This property is automatically set using a value from the `.dodsrc` configuration file. This method provides a way to override that behavior.

Note
  If the configuration file is not present or does not include a value for this property, it is set to `false`.

Parameters

  deflate | True sets the accept deflate property, False clears it.

Definition at line 1013 of file HTTPConnect.cc.

## set_cache_enabled()

void libdap::HTTPConnect::set_cache_enabled | ( | bool | enabled | ) |

inline

Set the state of the HTTP cache. By default, the HTTP cache is enabled or disabled using the value of the `USE_CACHE` property in the ``.dodsrc file. Use this method to set the state from within a program.

Parameters

  enabled | True to use the cache, False to disable.

Definition at line 151 of file HTTPConnect.h.

## set_cookie_jar()

void libdap::HTTPConnect::set_cookie_jar | ( | const string & | cookie_jar | ) |

inline

Set the cookie jar. This function sets the name of a file used to store cookies returned by servers. This will help with things like single sign on systems.

Parameters

  cookie_jar | The pathname to the file that stores cookies. If this is the empty string saving cookies is disabled.

Definition at line 144 of file HTTPConnect.h.

## set_credentials()

void libdap::HTTPConnect::set_credentials | ( | const string & | u,
|  | const string & | p
| ) |  |

Set the credentials for responding to challenges while dereferencing URLs. Alternatively, these can be embedded in the URL. This method provides a way for clients of HTTPConnect to get credentials from users (say using a pop up dialog) and to not hack the URL to pass that information to libcurl. Note that the 'credentials in the URL' scheme is part of the URL standard.

This method does nothing if `u`, the username, is empty.

Parameters

  u | The username.
  p | The password.

Exceptions

  InternalErr | The credentials could not be registered with libcurl.

See also
  extract_auth_info()

Definition at line 1079 of file HTTPConnect.cc.

## set_xdap_protocol()

void libdap::HTTPConnect::set_xdap_protocol | ( | int | major,
|  | int | minor
| ) |  |

Set the xdap_accept property/HTTP-header. This sets the value of the DAP which the client advertises to servers that it understands. The information (client protocol major and minor versions) are recorded in the instance and the information is sent to servers using the XDAP-Accept HTTP request header.

Parameters

  major | The dap client major protocol version
  minor | The dap client minor protocol version

Definition at line 1042 of file HTTPConnect.cc.

The documentation for this class was generated from the following files:

- HTTPConnect.h
- HTTPConnect.cc